#include <stdio.h>
#include <conio.h>

// Binary to decimal
#define         b0      1
#define         b8      256
#define         b16     65536
#define         b24     16777216

typedef unsigned char  byte;
typedef unsigned short word;

enum {NULLS,WEAPON,AMMO,EQUIPMENT,ACTUATOR,UNKOWN,WEAPONCONT};

enum {HD,CT,RT,LT,RA,LA,RL,LL,CTr,RTr,LTr};

int str[][5] =
 {{  0,  0, 0, 0, 0},
  {  5,  0, 0, 0, 0},
  { 10,  3, 2, 1, 2},
  { 15,  5, 4, 2, 3},
  { 20,  6, 5, 3, 4},
  { 25,  8, 6, 4, 6},
  { 30, 10, 7, 5, 7},
  { 35, 11, 8, 6, 8},
  { 40, 12,10, 6,10},
  { 45, 14,11, 7,11},
  { 50, 16,12, 8,12},
  { 55, 18,13, 9,13},
  { 60, 20,14,10,14},
  { 65, 21,15,10,15},
  { 70, 22,15,11,15},
  { 75, 23,16,12,16},
  { 80, 25,17,13,17},
  { 85, 27,18,14,18},
  { 90, 29,19,15,19},
  { 95, 30,20,16,20},
  {100, 31,21,17,21}};


typedef struct Crits {
char Class;
char Type;
char Size;
char State;
};

typedef struct WeaponData {
char Type;  // SMLS / MDLS
int  Loc ;
int  Ammo;  // -1 Energy
int  Damage;
char Status;
};

class rMech {
public:
int  TechBase;

char Name[40];
char Code[40];
int  Type;
int  Tons;
int  Walk;
int  Run;
int  Sprint;
int  Jump;

int  HeatSinks;

int  EngineType;
int  GyroType;
int  CockPitType;
int  SensorType;

int  MyomerType;
int  StructType;
int  ArmourType;
int  HeatSinkType;

int  NullSigType;
int  BAPType;
int  ECMType;
int  C3Type;
int  AMSType;
int  MASCType;
int  CompType;
int  ARTType;

int  CaseType;
int  CaseLoc;

int RightHatchetType;
int LeftHatchetType;
int LeftArm,RightArm;
int Armour[12];
int Struct[12];

int PrimeWeapon;

int NumWeap;
WeaponData Weapon[40];

int CritSlot[12];
Crits Crit[8][12];

} Mech;

Crits GetWeaponType( long Type );

int readStringLen(char *String, FILE *ReadFile, int Len)
{
int  i = 0;
for (i=0;i<Len;i++)
    String[i] = fgetc(ReadFile);

  String[i] = 0;
return i;
}

int readInt(FILE *ReadFile) {
int c;
c = fgetc(ReadFile);
c+= fgetc(ReadFile)*b8;
return c;
}

long int readLong(FILE *ReadFile) {
long int c;
c = fgetc(ReadFile);
c+= fgetc(ReadFile)*b8;
c+= fgetc(ReadFile)*b16;
c+= fgetc(ReadFile)*b24;
return c;
}

typedef struct WeapDat {

int Ammo;
int Number;

} Weapon[20];

Crits ConvertDBMCritType( int Type , int RearMod );
//int GetWeaponType ( int Type );
int ConvertDBMWeap( int Type );
int ConvertDBMLoc ( int Loc  );
int SaveMech      ();

int readCrits(int Loc, int Slot, FILE *file);

#define         lcase            32
#define         ucase           -32

int strcomp(char *String, char *Comp);



// Main
int main(int argc, char *argv[]) {
int i,j,k,l,m,n;
byte  ch;
char  String[160];
FILE *DBM;
/*
   if (argc != 2) {
      printf("Usage: MechName\n");
      return 1;
   }
*/
//DBM = fopen("vtr-9a~1.DBM","rb");
sprintf(String,"%s.DBM",argv[1]);
DBM = fopen(String,"rb");

// Quit if no file found
if (DBM==NULL) {
  printf("Invalid Mech Name\n");
  return 2;
  }
// Variables in read order
int  DBMver; // DBM ver 1 / 2 etc
int  Type, Tonnage;
char Name [30];
char Model[30];
int  Year;
int  Level;
long Cost;
int  BF2Length;
int  TechBase;
int  Legs; // Biped / Quad / LAM / Armless
int  ISType; // Standard / EndoSteel / Composite / Reinforced / Utility
int  EngineRating;
int  EngineType; // Fusion / XL / XXL / Compact / ICE
int  Walk;
int  Run;
int  Sprint;
int  Jump;
int  intHS;
int  HS;
int  HSType; // Standard / Double / Compact / Laser
int  ArmourType; // Standard / FerroFibre / Stealth / Reactive / Reflective
		 // Heavy FF / Light FF / Patchwork

int  Armour[12]; // Armour on Mech
int  MType;      // Myomer Type - Standard / Triple Strength / Masc
int  NumWeap;    // Number of Weapons

int  NumCrits;   // Number of Critical Slot - should be 76+1 for Normal Mechs
int  CritDex;    // Critical Index

clrscr();
// get Header (5 char)
readStringLen(String,DBM,0x19);

DBMver = readInt (DBM); // ?

if (DBMver != 1) {
  printf("Incorrect DBM version\n");
  printf("Currently only DBM version 1.xx supported\n");
  printf("%d \n",DBMver);
  return 3;
  }

i = readInt (DBM); // Name Len
readStringLen(Mech.Name ,DBM,i);
i = readInt (DBM); // Code Len
readStringLen(Mech.Code,DBM,i);
printf("%s : %s \n",Mech.Name,Mech.Code);

readInt (DBM);
readInt (DBM);
Mech.Tons    = readInt (DBM);

readStringLen(String,DBM,0x10); // Unknown

Mech.Walk    = readInt (DBM);
Run          = readInt (DBM);
Sprint       = readInt (DBM);
Mech.Jump    = readInt (DBM);

printf("Tons %d : Walk %d  Run %d  Sprint %d  Jump %d\n",Mech.Tons,Mech.Walk,Run,Sprint,Mech.Jump);

readStringLen(String,DBM,0x26);  // Unknown

intHS          = readInt (DBM);
Mech.HeatSinks = readInt (DBM);

printf("Internal Heat Sinks %d   Total Heat Sinks %d\n",intHS,Mech.HeatSinks);

readStringLen(String,DBM,0x0A); // Unknown
i = readInt (DBM); // Unknown
readStringLen(String,DBM,0xB4); // Unknown
readStringLen(String,DBM,0x10); // Breaker

Mech.NumWeap = readInt (DBM); // Number of Weapons and pieces of Equipment
Mech.NumWeap ++;

printf("Number of Weapons : %d \n",Mech.NumWeap);

k = 0;
for (i=0;i<Mech.NumWeap;i++) {
  j                   = ConvertDBMWeap( readInt(DBM) );

  readStringLen(String,DBM,0x0C); // Equipment Reader

  m                   = readInt(DBM) ;
//  m                   = ConvertDBMLoc ( readInt(DBM) );
  readStringLen(String,DBM,0x0C); // Equipment Reader
  if (j != -1) {
    Mech.Weapon[k].Type = j;
    Mech.Weapon[k].Loc  = m;
    printf(">>%d %d\n",j,m);
    k ++;
    }
  }

  Mech.NumWeap = k;
  
  Mech.Armour[LA]  = readInt (DBM);
  Mech.Armour[LT]  = readInt (DBM);
  Mech.Armour[LL]  = readInt (DBM);
  Mech.Armour[RL]  = readInt (DBM);
  Mech.Armour[RT]  = readInt (DBM);
  Mech.Armour[RA]  = readInt (DBM);
  Mech.Armour[CT]  = readInt (DBM);
  Mech.Armour[HD]  = readInt (DBM);
  Mech.Armour[LTr] = readInt (DBM);
  Mech.Armour[RTr] = readInt (DBM);
  Mech.Armour[CTr] = readInt (DBM);


printf("Armour Table :\n");
printf("        %2d\n",Mech.Armour[HD]);
printf("%2d  %2d  %2d",Mech.Armour[LA],Mech.Armour[LT],Mech.Armour[CT]);
printf("  %2d  %2d\n",Mech.Armour[RT],Mech.Armour[RA]);
printf("    %2d     %2d\n",Mech.Armour[LL],Mech.Armour[RL]);

NumCrits = readInt(DBM); // Number of Criticals for a mech, usually 76+1

// Read Crits from File

  readCrits(LA,12,DBM);
  readCrits(LT,12,DBM);
  readCrits(LL,6,DBM);
  readCrits(RL,6,DBM);
  readCrits(RT,12,DBM);
  readCrits(RA,12,DBM);
  readCrits(CT,12,DBM);
  readCrits(HD,6,DBM);

//for (i=0;i<0x10;i++)
//  printf("%d\n",String[i]);

fclose(DBM);
//for (i=0;i<8;i++)
//  printf("%d\n",Mech.CritSlot[i]);


SaveMech();

return 0;
}

Crits ConvertDBMCritType( int Type , char RearMod ) {
Crits a;
//printf("%ld\n",Type);
//if (RearMod == 255) RearMod = -1;
//RearMod = 0;

        a.Class = NULLS;
        a.Type  = -1;
        a.Size  = 1;
        a.State = 0;

	if( Type == -1 ) {a.Type = 0; return a;} // Null Set

/* DBM uses different Settings

	if( Type == 0x01 ) a.Type = 0;
	if( Type == 0x02 ) a.Type = 1;
	if( Type == 0x03 ) a.Type = 2;
	if( Type == 0x04 ) a.Type = 3;
	
	if( Type == 0x05 ) a.Type = 4;
	if( Type == 0x06 ) a.Type = 5;
	if( Type == 0x07 ) a.Type = 6;
	if( Type == 0x08 ) a.Type = 7;

	if( Type == 0x0C ) a.Type =10;
	if( Type == 0x0D ) a.Type =12;
	if( Type == 0x0E ) a.Type =11;

*/
        a.Class  = ACTUATOR;
        a.Size   = 1;
        a.State  = 1;

	if( Type == 0x03F3 ) a.Type = 8;
	if( Type == 0x03F4 ) a.Type = 9;

        if (a.Type != -1) return a; // Actuator Set

        a.Class  = EQUIPMENT;
        a.State  = 1;
	if( Type == 0x03EC ) a.Type = 0, a.Size = 1; // Heat Sink
//	if( Type ==        ) a.Type = 0, a.Size = 3; // Can Only Handle StarLeague
	if( Type == 0x03F5 ) a.Type = 1, a.Size = 1; // Jump Jet

        if (a.Type != -1) return a; // Equipment Set

        a.Class = WEAPON;
	a.State = RearMod;
	if( Type == 0x14 ) a.Type = 0, a.Size = 1;
	if( Type == 0x15 ) a.Type = 1, a.Size = 2;
	if( Type == 0x16 ) a.Type = 2, a.Size = 1;
	if( Type == 0x18 ) a.Type = 3, a.Size = 1;
	if( Type == 0x17 ) a.Type = 4, a.Size = 3;

	if( Type == 0x1A ) a.Type = 5, a.Size = 1;
	if( Type == 0x1C ) a.Type = 6, a.Size = 4;
	if( Type == 0x19 ) a.Type = 7, a.Size = 7;
	if( Type == 0x1B ) a.Type = 8, a.Size =10;
	if( Type == 0x1D ) a.Type = 9, a.Size = 1;

	if( Type == 0x24 ) a.Type =10, a.Size = 1;
	if( Type == 0x1E ) a.Type =11, a.Size = 2;
	if( Type == 0x20 ) a.Type =12, a.Size = 3;
	if( Type == 0x22 ) a.Type =13, a.Size = 5;

	if( Type == 0x26 ) a.Type =14, a.Size = 1;
	if( Type == 0x28 ) a.Type =15, a.Size = 1;
	if( Type == 0x2A ) a.Type =16, a.Size = 2;

        if (a.Type != -1) return a; // Weapon Set

//	Type &= 0xFFFF;

        a.Class = AMMO;
        a.Size  = 1;

	if( Type == 0x002E ) a.Type = 0, a.State =  45;
	if( Type == 0x0030 ) a.Type = 1, a.State =  20;
	if( Type == 0x002D ) a.Type = 2, a.State =  10;
	if( Type == 0x002F ) a.Type = 3, a.State =   5;
	if( Type == 0x0035 ) a.Type = 4, a.State = 200;
	if( Type == 0x0036 ) a.Type = 4, a.State = 100;

	if( Type == 0x0034 ) a.Type = 5, a.State =  24;
	if( Type == 0x0031 ) a.Type = 6, a.State =  12;
	if( Type == 0x0032 ) a.Type = 7, a.State =   8;
	if( Type == 0x0033 ) a.Type = 8, a.State =   6;

	if( Type == 0x0037 ) a.Type = 9, a.State =  50;
	if( Type == 0x0039 ) a.Type =10, a.State =  25;
	if( Type == 0x003A ) a.Type =11, a.State =  15;
//	if( Type == 0x0215 ) a.Type =13, a.State =  10;

        if (a.Type != -1) return a; // Ammo Set
        // Roll Again Slot
        a.Class = NULLS;
        a.Type  = 0;
        a.Size  = 1;
        a.State = 0;

return a;
}

int ConvertDBMWeap(int Type) {
int a = -1;

  if (Type == 0x14) a = 0; // Flamer
  if (Type == 0x15) a = 1; // Large Laser
  if (Type == 0x16) a = 2; // Medium Laser
  if (Type == 0x18) a = 3; // Small Laser
  if (Type == 0x17) a = 4; // PPC

  if (Type == 0x1A) a = 5; // AC/2
  if (Type == 0x1C) a = 6; // AC/5
  if (Type == 0x19) a = 7; // AC/10
  if (Type == 0x1B) a = 8; // AC/20
  if (Type == 0x1D) a = 9; // MG

  if (Type == 0x24) a =10; // LRM 5
  if (Type == 0x1E) a =11; // LRM 10
  if (Type == 0x20) a =12; // LRM 15
  if (Type == 0x22) a =13; // LRM 20
  if (Type == 0x26) a =14; // SRM 2
  if (Type == 0x28) a =15; // SRM 4
  if (Type == 0x2A) a =16; // SRM 6

//  printf(">> %d\n",a);

return a;
}

Crits ConvertDBMCrit(int Len, char *String) {
Crits a;

a.Class = ACTUATOR;
a.Size  = 1;
a.State = 1;

  if (strcomp(String,"Shoulder")) a.Type = 0;
  if (strcomp(String,"Upper Arm Actuator")) a.Type = 1;
  if (strcomp(String,"Lower Arm Actuator")) a.Type = 2;
  if (strcomp(String,"Hand Actuator")) a.Type = 3;
  if (strcomp(String,"Hip")) a.Type = 4;
  if (strcomp(String,"Upper Leg Actuator")) a.Type = 5;
  if (strcomp(String,"Lower Leg Actuator")) a.Type = 6;
  if (strcomp(String,"Foot Actuator")) a.Type = 7;

  if (strcomp(String,"Life Support")) a.Type = 10;
  if (strcomp(String,"Cockpit")) a.Type = 11;
  if (strcomp(String,"Sensors")) a.Type = 12;

return a;
}


int ConvertDBMLoc (int Loc) {

	if( Loc == 0 ) return 5;
	if( Loc == 1 ) return 3;
	if( Loc == 2 ) return 7;
	if( Loc == 3 ) return 6;
	if( Loc == 4 ) return 2;
	if( Loc == 5 ) return 4;
	if( Loc == 7 ) return 0;
	if( Loc == 6 ) return 1;
/*
	if( Loc == 1 ) return 5;
	if( Loc == 2 ) return 3;
	if( Loc == 3 ) return 7;
	if( Loc == 4 ) return 4;
	if( Loc == 5 ) return 2;
	if( Loc == 6 ) return 6;
	if( Loc == 7 ) return 0;
	if( Loc == 8 ) return 1;
	if( Loc == 0x0A ) return 10;
	if( Loc == 0x0D ) return  9;
	if( Loc == 0x0F ) return 15;
	if( Loc == 0x10 ) return  8;
*/
return 1;
}

int writeString(char *String, FILE *fout) {
int i = 0;
while (String[i] != 0x0000) putc(String[i],fout), i++;
putc(0x0000,fout); // Write a Terminator to the File
return i;
}


int SaveMech()
{
char String[30];
FILE *MechOut;

//sprintf(String,"save.mec");
sprintf(String,"%s.mec",Mech.Code);

//while (String[i] != 0) String[i] = Code[i];

MechOut = fopen(String,"wb");
if (MechOut == NULL) return 1;
/////////////////////////////////////////////////////////////////////////////
// File Header
// ALWAYS 12 BYTES in length
//

fputc(0,MechOut);          // 0 - BattleMech 1 - Vehicle etc..
fputc(Mech.TechBase,MechOut);          // 0 - InnerSphere 1 - StarLeague 2 - Clan 3 - Custom
writeString("BTV0.1a",MechOut);  // File Class
fputc('1',MechOut);           // IE Version 1.0, 2.0
fputc('9' ,MechOut);           // IE Version  .2   .7
fputc('A' ,MechOut);           // Release Version  / Alpha / Beta / Gamma

writeString(Mech.Name,MechOut);
writeString(Mech.Code,MechOut);

fputc(Mech.Type,MechOut);       //  0 - Biped 1 - Quad 2 - Lam 3 - OmniMech

fputc(Mech.Tons,MechOut);
fputc(Mech.Walk,MechOut);
fputc(Mech.Jump,MechOut);

// Pod Weight?

//putc(HeatSinkType) // 0 - Normal 1 - Double 2 - Clan 3 - Compact 4 - Laser
fputc(Mech.HeatSinks,MechOut);

  if (Mech.Crit[4][3].Class == 4 && Mech.Crit[5][3].Type == 3)
    Mech.RightArm = 4;
    else
    if (Mech.Crit[4][2].Class == 4 && Mech.Crit[5][2].Type == 2)
      Mech.RightArm = 3;
    else
      Mech.RightArm = 2;

//if (Mech.Crit[5][3].Class == 4 && Mech.Crit[5][3].Type == 14) // Hatchet
  if (Mech.Crit[5][3].Class == 4 && Mech.Crit[5][3].Type == 3)
    Mech.LeftArm = 4;
    else
    if (Mech.Crit[5][2].Class == 4 && Mech.Crit[5][2].Type == 2)
      Mech.LeftArm = 3;
    else
      Mech.LeftArm = 2;

  if (Mech.RightHatchetType == 1)
    Mech.RightArm = 5;
  if (Mech.LeftHatchetType  == 1)
    Mech.LeftArm = 5;

//printf(">>  %d %d\n",RightHatchet,LeftHatchet);
//printf("RA >>> %d,\n",Mech.RightArm);
//printf("LA >>> %d,\n",Mech.LeftArm);

fputc(Mech.LeftArm ,MechOut); // The Arms Length, 2-4
fputc(Mech.RightArm,MechOut);
//ptinyg
int i,j;             // 0 1 2 3 4 5 6 7 8 9 0
for (i=0;i<11;i++) {
  fputc(Mech.Armour[i],MechOut);
//  printf("%d\n",Mech.Armour[i]);
  }
/*
for (i=0;i<8 ;i++) {
  fputc(Mech.Struct[i],MechOut);
  }
*/
fputc(3,MechOut);
fputc(str[Mech.Tons/5][1],MechOut);
fputc(str[Mech.Tons/5][2],MechOut);
fputc(str[Mech.Tons/5][2],MechOut);
fputc(str[Mech.Tons/5][3],MechOut);
fputc(str[Mech.Tons/5][3],MechOut);
fputc(str[Mech.Tons/5][4],MechOut);
fputc(str[Mech.Tons/5][4],MechOut);

// Derived

//int   MaxAF,CurAF;
//float MaxArmourTons,CurArmourTons;

  fputc(127,MechOut); // End Main
// Put Equipment Type

fputc(Mech.EngineType  ,MechOut);
fputc(Mech.GyroType    ,MechOut);
fputc(Mech.CockPitType ,MechOut);
fputc(Mech.SensorType  ,MechOut);

fputc(Mech.MyomerType  ,MechOut);
fputc(Mech.StructType  ,MechOut);
fputc(Mech.ArmourType  ,MechOut);
fputc(Mech.HeatSinkType,MechOut);

fputc(Mech.NullSigType ,MechOut);
fputc(Mech.BAPType     ,MechOut);
fputc(Mech.ECMType     ,MechOut);
fputc(Mech.C3Type      ,MechOut);

fputc(Mech.AMSType     ,MechOut);
fputc(Mech.MASCType    ,MechOut);
fputc(Mech.CompType    ,MechOut);
fputc(Mech.ARTType     ,MechOut);

if (Mech.TechBase > 3) {
  Mech.CaseType = 1;
  Mech.CaseLoc  = 255; }

fputc(Mech.CaseType    ,MechOut);
fputc(Mech.CaseLoc     ,MechOut);

fputc(Mech.RightHatchetType ,MechOut);
fputc(Mech.LeftHatchetType  ,MechOut);

  fputc(127,MechOut); // End Type

//genWeaponTable();
fputc(Mech.NumWeap, MechOut);
//printf("%d\n",Mech.Weapons<<2);
for (i=0;i<Mech.NumWeap;i++) {
  fputc(Mech.Weapon[i].Type,MechOut);
  fputc(Mech.Weapon[i].Loc ,MechOut);
  }

  fputc(127,MechOut); // End Weapon

for (i=0;i<8;i++) {
  fputc(Mech.CritSlot[i],MechOut);
//  printf(">> %d\n",Mech.CritSlot[i]);
  for (j=0;j<Mech.CritSlot[i];j++) {
    fputc(Mech.Crit[i][j].Class ,MechOut);
    fputc(Mech.Crit[i][j].Type  ,MechOut);
    fputc(Mech.Crit[i][j].Size  ,MechOut);
    fputc(Mech.Crit[i][j].State ,MechOut);
    printf("%d %d\n",Mech.Crit[i][j].Class,Mech.Crit[i][j].Type);
    }
  }

  fputc(127,MechOut); // End Crit
//Put Terminators
fclose(MechOut);
return 0;
}

char isLetter(char input)
{
if ((input >= 97) && (input <=122) || (input >= 65) && (input <=90))
  return 1;

return 0;
}

char isDigit(char input)
{
if ((input >= 48) && (input <=57))
  return 1;

return 0;
}

int strlength(char *String) {
int i=0;
while (String[i] != 0x0000) i++;

return i;
}


int strcomp(char *String, char *Comp) {

int i,j=0;
int l = strlength(Comp);

  for (i=0;i<l;i++) {

    if (String[i] == Comp[i]) j++;
      else {
    if (isLetter(String[i]) == 1 && String[i] == Comp[i] + lcase) j++;
    if (isLetter(String[i]) == 1 && String[i] == Comp[i] + ucase) j++; }

  }

return !(l-j);
}


int procNumber(char *String) {
int i=0,len,num=0;
int NegFlag = 1;

  len = strlength(String);

  if (String[i] == '-') NegFlag = -1;

  while (String[i] != '=' && i <= len) i++;
    if (i >= len) i = 0;
  while (!isDigit ( String[i] ) ) i++;
  while (String[i] != 0x0000 && isDigit(String[i])) num *= 10, num += String[i] - 48, i++;

  num *= NegFlag;

return num;
}


int readCrits(int Loc, int Slots, FILE *file) {
char String[200];
Crits CritTemp;
int CritDex;
int i,j,k,l,m,n;
char RearMod;

m = 0;
j = 0;
Mech.CritSlot[Loc] = 0;

for (n=0;n<Slots-m;n++) {

// Start of Crit Read
  RearMod = 0;
  CritTemp.Class = 0;
  CritTemp.Type  = 0;
  

  i = readInt(file); // Length of Critical Name
  readStringLen(String,file,i); // reads any critical name
//  printf(">>%d %s",i,String);

  if (i > 0)
    CritTemp = ConvertDBMCrit(i,String);

    CritDex = readInt(file); // Self Indexing Number for Location
    readStringLen(String,file,0x10); // reads critical Misc.

    RearMod = readInt(file); // 0 Normal, -1/65535 RearMod
              readInt(file); // Misc Int

    i       = readInt(file); // Length of Critical Number
    readStringLen(String,file,i); // Refrences Weapon Table

    i       = readInt(file); // -1, for nothing or Weapon Type

//    printf("   %s      %d\n",String, i);

//  printf(" C:%d \n",i);

  if (i != -1 && i != 65535)
    CritTemp = ConvertDBMCritType(i,RearMod);

// End of Main Crit Read
//  if (CritTemp.Class != 0 && CritTemp.Type != 0)
    Mech.Crit[Loc][j] = CritTemp;

//  printf(" C:%d T:%d S:%d\n",CritTemp.Class,CritTemp.Type,CritTemp.Size);

  if (Mech.Crit[Loc][j].Size > 1) {
    l = Mech.Crit[Loc][j].Size;
//    printf(" C:%d \n",l);
    for (k=0;k<l-1;k++) {
      m++;
      // Reads Repeating Info
      i = readInt(file); // Length of Critical Name
      readStringLen(String,file,i); // reads any critical name

      CritDex = readInt(file); // Self Indexing Number for Location
      readStringLen(String,file,0x14); // reads critical Misc.

      i       = readInt(file); // Length of Critical Number
      readStringLen(String,file,i); // Refrences Weapon Table
      i       = readInt(file); // -1, for nothing or Weapon Type

      }
  }

  if (Mech.Crit[Loc][j].Class != 0) {// && Mech.Crit[Loc][j].Type != 0) {
    Mech.CritSlot[Loc] ++;
//    printf("-----> \n");
    j ++;
    }

}

//printf(">>>> C:%d \n",Mech.CritSlot[Loc]);
//getch();
return 0;
}
/*
  m = 0;
  for( i=0;i<12-m;i++ )
  {
  Crit[j][i] = GetWeaponType(readLong(HMP));

  if (Crit[j][i].Class != 0)
    CritSlot[j] ++;

  if (Crit[j][i].Size > 1) {
    l = Crit[j][i].Size;
    for (k=0;k<l-1;k++) {
      m++; readLong(HMP); // Read Repeating Info
      }
      }

  }
*/
